package dev.peerat.parser;

import java.util.function.BiConsumer;
import java.util.function.Function;

public class TokenValidator{
	
	public static int MAX_VALIDATE = 0;
	public static int TOKENS = 0;
	
	private Token[] elements;
	private int index;
	private int validated;
	
	private Bag bag;
	
	private TokenValidator(Bag bag){
		this.bag = bag;
	}
	
	public TokenValidator(Token[] elements){
		this.elements = elements;
		this.bag = new Bag();
	}
	
	public boolean hasNext(){
		return validated < elements.length;
	}
	
	public boolean validate(Function<Token, Boolean> action){
		if(validated >= this.elements.length) return false;
		if(action.apply(this.elements[validated])){
			if(validated+1 > MAX_VALIDATE){
				MAX_VALIDATE = validated+1;
				TOKENS = elements.length;
			}
			this.validated++;
			
			return true;
		}
		return false;
	}
	
	public boolean validate(Function<Token, Boolean> action, BiConsumer<Bag, Token> filler){
		if(validate(action)){
			filler.accept(bag, elements[validated-1]);
			return true;
		}
		return false;
	}
	
	public TokenValidator branch(){
		TokenValidator branch = new TokenValidator(bag);
		branch.elements = this.elements;
		branch.index = Math.max(0, this.validated-1);
		branch.validated = this.validated;
		return branch;
	}
	
	public void merge(TokenValidator branch){
		this.index = branch.index;
		this.validated = branch.validated;
		this.bag = branch.bag;
	}
	
	public void setBag(Bag bag){
		this.bag = bag;
	}
	
	public Bag getBag(){
		return this.bag;
	}
	
}
