package dev.peerat.parser.java.tree;

import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.state.StateTree;
import dev.peerat.parser.tree.SyntaxTree;
import dev.peerat.parser.tree.SyntaxTreeRegistery;

public class ClassContainerTree extends SyntaxTree<JavaElement> {

	public ClassContainerTree(SyntaxTreeRegistery<JavaElement> registery) {
		super(registery);
		this.current = new StateTree<>();
	}

	@Override
	public void init(){
		StateTree<JavaElement> clazz_ = this.registery.getNode(ClassBaseTree.class);
		StateTree<JavaElement> function = this.registery.getNode(FunctionTree.class);
		StateTree<JavaElement> variable = this.registery.getNode(VariableTree.class);
		StateTree<JavaElement> function_container = this.registery.getNode(FunctionContainerTree.class);
		
		StateTree<JavaElement> clazz_container = this.current;
		clazz_container.then((validator) -> validator.validate((token) -> token.getValue().equals(";")))
				.end((a, b) -> a);
		
		clazz_container.then(function);
		clazz_container.then(variable);
		
		clazz_container.then((validator) -> validator.validate((token) -> token.getValue().equals("{")))
			.end((a,b) -> a)
				.multiple(function_container)
				.unique((validator) -> validator.validate((token) -> token.getValue().equals("{")))
				.end((a,b) -> a);
		
		clazz_container.then(clazz_);
	}

}
