package dev.peerat.parser.java.element;

import java.util.Arrays;
import java.util.List;

import org.junit.jupiter.api.Test;

import dev.peerat.parser.java.element.annotation.ClazzAnnotation;
import dev.peerat.parser.java.element.clazz.ClazzWithExtend;
import dev.peerat.parser.java.element.clazz.ClazzWithExtendsAndImplements;
import dev.peerat.parser.java.element.clazz.ClazzWithImplements;
import dev.peerat.parser.java.element.clazz.ClazzWithMod;
import dev.peerat.parser.java.element.clazz.ClazzWithoutMod;
import dev.peerat.parser.java.element.clazz.EnumWithImplements;
import dev.peerat.parser.java.element.clazz.EnumWithMod;
import dev.peerat.parser.java.element.clazz.EnumWithoutMod;
import dev.peerat.parser.java.element.clazz.InterfaceWithExtends;
import dev.peerat.parser.java.element.clazz.InterfaceWithMod;
import dev.peerat.parser.java.element.clazz.InterfaceWithoutMod;
import dev.peerat.parser.java.element.function.ConstructorFunction;
import dev.peerat.parser.java.element.function.NormalFunction;
import dev.peerat.parser.java.element.function.StaticFunction;
import dev.peerat.parser.java.element.operation.AssignOperationTest;
import dev.peerat.parser.java.element.operation.LoopOperationTests;
import dev.peerat.parser.java.element.variable.VariableInClass;
import dev.peerat.parser.java.element.variable.VariableInMethod;

public class CITests{
	
	List<BaseElementTests> TESTS = Arrays.asList(
			new ClazzAnnotation(),
			new ClazzWithExtend(),
			new ClazzWithExtendsAndImplements(),
			new ClazzWithImplements(),
			new ClazzWithMod(),
			new ClazzWithoutMod(),
			new EnumWithImplements(),
			new EnumWithMod(),
			new EnumWithoutMod(),
			new InterfaceWithExtends(), 
			new InterfaceWithMod(),
			new InterfaceWithoutMod(),
			new ConstructorFunction(),
			new StaticFunction(),
			new NormalFunction(),
			new VariableInClass(),
			new VariableInMethod(),
			new AssignOperationTest(),
			new LoopOperationTests()
			);
	
	@Test
	void main(){
		for(BaseElementTests test : TESTS) test.main();
	}

}
